from _typeshed import Incomplete
from mongoengine.base import BaseField, ComplexBaseField, GeoJsonBaseField as GeoJsonBaseField, ObjectIdField as ObjectIdField

class StringField(BaseField):
    regex: Incomplete
    max_length: Incomplete
    min_length: Incomplete
    def __init__(self, regex: Incomplete | None = ..., max_length: Incomplete | None = ..., min_length: Incomplete | None = ..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def validate(self, value) -> None: ...
    def lookup_member(self, member_name) -> None: ...
    def prepare_query_value(self, op, value): ...

class URLField(StringField):
    url_regex: Incomplete
    schemes: Incomplete
    def __init__(self, url_regex: Incomplete | None = ..., schemes: Incomplete | None = ..., **kwargs) -> None: ...
    def validate(self, value) -> None: ...

class EmailField(StringField):
    USER_REGEX: Incomplete
    UTF8_USER_REGEX: Incomplete
    DOMAIN_REGEX: Incomplete
    error_msg: str
    domain_whitelist: Incomplete
    allow_utf8_user: Incomplete
    allow_ip_domain: Incomplete
    def __init__(self, domain_whitelist: Incomplete | None = ..., allow_utf8_user: bool = ..., allow_ip_domain: bool = ..., *args, **kwargs) -> None: ...
    def validate_user_part(self, user_part): ...
    def validate_domain_part(self, domain_part): ...
    def validate(self, value) -> None: ...

class IntField(BaseField):
    def __init__(self, min_value: Incomplete | None = ..., max_value: Incomplete | None = ..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class LongField(BaseField):
    def __init__(self, min_value: Incomplete | None = ..., max_value: Incomplete | None = ..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def to_mongo(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class FloatField(BaseField):
    def __init__(self, min_value: Incomplete | None = ..., max_value: Incomplete | None = ..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class DecimalField(BaseField):
    min_value: Incomplete
    max_value: Incomplete
    force_string: Incomplete
    precision: Incomplete
    rounding: Incomplete
    def __init__(self, min_value: Incomplete | None = ..., max_value: Incomplete | None = ..., force_string: bool = ..., precision: int = ..., rounding=..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def to_mongo(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class BooleanField(BaseField):
    def to_python(self, value): ...
    def validate(self, value) -> None: ...

class DateTimeField(BaseField):
    def validate(self, value) -> None: ...
    def to_mongo(self, value): ...
    def prepare_query_value(self, op, value): ...

class DateField(DateTimeField):
    def to_mongo(self, value): ...
    def to_python(self, value): ...

class ComplexDateTimeField(StringField):
    separator: Incomplete
    format: Incomplete
    def __init__(self, separator: str = ..., **kwargs) -> None: ...
    def __get__(self, instance, owner): ...
    def __set__(self, instance, value) -> None: ...
    def validate(self, value) -> None: ...
    def to_python(self, value): ...
    def to_mongo(self, value): ...
    def prepare_query_value(self, op, value): ...

class EmbeddedDocumentField(BaseField):
    document_type_obj: Incomplete
    def __init__(self, document_type, **kwargs) -> None: ...
    @property
    def document_type(self): ...
    def to_python(self, value): ...
    def to_mongo(self, value, use_db_field: bool = ..., fields: Incomplete | None = ...): ...
    def validate(self, value, clean: bool = ...) -> None: ...
    def lookup_member(self, member_name): ...
    def prepare_query_value(self, op, value): ...

class GenericEmbeddedDocumentField(BaseField):
    def prepare_query_value(self, op, value): ...
    def to_python(self, value): ...
    def validate(self, value, clean: bool = ...): ...
    def lookup_member(self, member_name): ...
    def to_mongo(self, document, use_db_field: bool = ..., fields: Incomplete | None = ...): ...

class DynamicField(BaseField):
    def to_mongo(self, value, use_db_field: bool = ..., fields: Incomplete | None = ...): ...
    def to_python(self, value): ...
    def lookup_member(self, member_name): ...
    def prepare_query_value(self, op, value): ...
    def validate(self, value, clean: bool = ...) -> None: ...

class ListField(ComplexBaseField):
    max_length: Incomplete
    def __init__(self, field: Incomplete | None = ..., max_length: Incomplete | None = ..., **kwargs): ...
    def __get__(self, instance, owner): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class EmbeddedDocumentListField(ListField):
    def __init__(self, document_type, **kwargs) -> None: ...

class SortedListField(ListField):
    def __init__(self, field, **kwargs) -> None: ...
    def to_mongo(self, value, use_db_field: bool = ..., fields: Incomplete | None = ...): ...

class DictField(ComplexBaseField):
    def __init__(self, field: Incomplete | None = ..., *args, **kwargs): ...
    def validate(self, value) -> None: ...
    def lookup_member(self, member_name): ...
    def prepare_query_value(self, op, value): ...

class MapField(DictField):
    def __init__(self, field: Incomplete | None = ..., *args, **kwargs) -> None: ...

class ReferenceField(BaseField):
    dbref: Incomplete
    document_type_obj: Incomplete
    reverse_delete_rule: Incomplete
    def __init__(self, document_type, dbref: bool = ..., reverse_delete_rule=..., **kwargs) -> None: ...
    @property
    def document_type(self): ...
    def __get__(self, instance, owner): ...
    def to_mongo(self, document): ...
    def to_python(self, value): ...
    def prepare_query_value(self, op, value): ...
    def validate(self, value) -> None: ...
    def lookup_member(self, member_name): ...

class CachedReferenceField(BaseField):
    auto_sync: Incomplete
    document_type_obj: Incomplete
    fields: Incomplete
    def __init__(self, document_type, fields: Incomplete | None = ..., auto_sync: bool = ..., **kwargs) -> None: ...
    def start_listener(self) -> None: ...
    def on_document_pre_save(self, sender, document, created, **kwargs) -> None: ...
    def to_python(self, value): ...
    @property
    def document_type(self): ...
    def __get__(self, instance, owner): ...
    def to_mongo(self, document, use_db_field: bool = ..., fields: Incomplete | None = ...): ...
    def prepare_query_value(self, op, value): ...
    def validate(self, value) -> None: ...
    def lookup_member(self, member_name): ...
    def sync_all(self) -> None: ...

class GenericReferenceField(BaseField):
    choices: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def __get__(self, instance, owner): ...
    def validate(self, value) -> None: ...
    def to_mongo(self, document): ...
    def prepare_query_value(self, op, value): ...

class BinaryField(BaseField):
    max_bytes: Incomplete
    def __init__(self, max_bytes: Incomplete | None = ..., **kwargs) -> None: ...
    def __set__(self, instance, value): ...
    def to_mongo(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...

class EnumField(BaseField):
    def __init__(self, enum, **kwargs) -> None: ...
    def __set__(self, instance, value): ...
    def to_mongo(self, value): ...
    def prepare_query_value(self, op, value): ...

class GridFSError(Exception): ...

class GridFSProxy:
    grid_id: Incomplete
    key: Incomplete
    instance: Incomplete
    db_alias: Incomplete
    collection_name: Incomplete
    newfile: Incomplete
    gridout: Incomplete
    def __init__(self, grid_id: Incomplete | None = ..., key: Incomplete | None = ..., instance: Incomplete | None = ..., db_alias=..., collection_name: str = ...) -> None: ...
    def __getattr__(self, name): ...
    def __get__(self, instance, value): ...
    def __bool__(self): ...
    def __copy__(self): ...
    def __deepcopy__(self, memo): ...
    def __eq__(self, other): ...
    def __ne__(self, other): ...
    @property
    def fs(self): ...
    def get(self, grid_id: Incomplete | None = ...): ...
    def new_file(self, **kwargs) -> None: ...
    def put(self, file_obj, **kwargs) -> None: ...
    def write(self, string) -> None: ...
    def writelines(self, lines) -> None: ...
    def read(self, size: int = ...): ...
    def delete(self) -> None: ...
    def replace(self, file_obj, **kwargs) -> None: ...
    def close(self) -> None: ...

class FileField(BaseField):
    proxy_class: Incomplete
    collection_name: Incomplete
    db_alias: Incomplete
    def __init__(self, db_alias=..., collection_name: str = ..., **kwargs) -> None: ...
    def __get__(self, instance, owner): ...
    def __set__(self, instance, value) -> None: ...
    def get_proxy_obj(self, key, instance, db_alias: Incomplete | None = ..., collection_name: Incomplete | None = ...): ...
    def to_mongo(self, value): ...
    def to_python(self, value): ...
    def validate(self, value) -> None: ...

class ImageGridFsProxy(GridFSProxy):
    def put(self, file_obj, **kwargs): ...
    def delete(self, *args, **kwargs): ...
    @property
    def size(self): ...
    @property
    def format(self): ...
    @property
    def thumbnail(self): ...
    def write(self, *args, **kwargs) -> None: ...
    def writelines(self, *args, **kwargs) -> None: ...

class ImproperlyConfigured(Exception): ...

class ImageField(FileField):
    proxy_class: Incomplete
    def __init__(self, size: Incomplete | None = ..., thumbnail_size: Incomplete | None = ..., collection_name: str = ..., **kwargs) -> None: ...

class SequenceField(BaseField):
    COLLECTION_NAME: str
    VALUE_DECORATOR: Incomplete
    collection_name: Incomplete
    db_alias: Incomplete
    sequence_name: Incomplete
    value_decorator: Incomplete
    def __init__(self, collection_name: Incomplete | None = ..., db_alias: Incomplete | None = ..., sequence_name: Incomplete | None = ..., value_decorator: Incomplete | None = ..., *args, **kwargs) -> None: ...
    def generate(self): ...
    def set_next_value(self, value): ...
    def get_next_value(self): ...
    def get_sequence_name(self): ...
    def __get__(self, instance, owner): ...
    def __set__(self, instance, value): ...
    def prepare_query_value(self, op, value): ...
    def to_python(self, value): ...

class UUIDField(BaseField):
    def __init__(self, binary: bool = ..., **kwargs) -> None: ...
    def to_python(self, value): ...
    def to_mongo(self, value): ...
    def prepare_query_value(self, op, value): ...
    def validate(self, value) -> None: ...

class GeoPointField(BaseField):
    def validate(self, value) -> None: ...

class PointField(GeoJsonBaseField): ...
class LineStringField(GeoJsonBaseField): ...
class PolygonField(GeoJsonBaseField): ...
class MultiPointField(GeoJsonBaseField): ...
class MultiLineStringField(GeoJsonBaseField): ...
class MultiPolygonField(GeoJsonBaseField): ...

class LazyReferenceField(BaseField):
    dbref: Incomplete
    passthrough: Incomplete
    document_type_obj: Incomplete
    reverse_delete_rule: Incomplete
    def __init__(self, document_type, passthrough: bool = ..., dbref: bool = ..., reverse_delete_rule=..., **kwargs) -> None: ...
    @property
    def document_type(self): ...
    def build_lazyref(self, value): ...
    def __get__(self, instance, owner): ...
    def to_mongo(self, value): ...
    def to_python(self, value): ...
    def validate(self, value) -> None: ...
    def prepare_query_value(self, op, value): ...
    def lookup_member(self, member_name): ...

class GenericLazyReferenceField(GenericReferenceField):
    passthrough: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def build_lazyref(self, value): ...
    def __get__(self, instance, owner): ...
    def validate(self, value): ...
    def to_mongo(self, document): ...
